/**
 * 
 */
package edu.uoc.framework.Main;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import edu.uoc.framework.process.DataGeneratorProcess;
import edu.uoc.framework.process.InsertProcess;
import edu.uoc.framework.process.ReadProcess;

/**
 * @author JBuch
 *
 */
@Service
public class Generator {

	private Package pkg;
	private List<Class<?>> listClass;
	private List<Object> listEntitys;
	
	@Autowired
	ReadProcess read;
	
	@Autowired
	DataGeneratorProcess dataGen;
	
	@Autowired
	InsertProcess insert;
	
	public void run(){
		
		runRead();
		runDatagenerator();
		runInsert();
		System.out.println("Framwork execute Correctly");
	}

	private void runRead() {		
		listClass = read.execute(pkg);
	}
	
	private void runDatagenerator() {
		listEntitys = dataGen.execute(listClass);
	}

	private void runInsert() {
		insert.execute(listEntitys);	
	}
	
	public Package getPkg() {
		return pkg;
	}

	public void setPkg(Package pkg) {
		this.pkg = pkg;
	}

	public List<Class<?>> getListClass() {
		return listClass;
	}

	public void setListClass(List<Class<?>> listClass) {
		this.listClass = listClass;
	}

	public List<Object> getListEntitys() {
		return listEntitys;
	}

	public void setListEntitys(List<Object> listEntitys) {
		this.listEntitys = listEntitys;
	}

}
