/**
 * 
 */
package edu.uoc.framework.generator.entity;

import java.lang.reflect.Type;
import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import edu.uoc.framework.common.ConstantsType;
import edu.uoc.framework.exception.TypeAcceptException;
import edu.uoc.framework.generator.entity.RandomGenerator.RandomGenerator;

/**
 * @author JBuch
 * 
 */
@Service
public class DataFieldGenerator {

	@Autowired
	RandomGenerator randomGenerator;

	public Object getValue(Type type, boolean nullable, int length,
			int precision, int scale) throws TypeAcceptException {

		Object value = null;

		int typeInstance = getIntByType(type);
		if (typeInstance > 0) {
			value = randomGenerator.getRandomValue(typeInstance, nullable,
					length, precision, scale);
		} else {
			value = type;
		}

		return value;
	}

	private static int getIntByType(Type type) throws TypeAcceptException {
		int typeInstance = 0;
		if (type.equals(String.class)) {
			typeInstance = ConstantsType.STRING_TYPE;
		} else if (type.equals(boolean.class)) {
			typeInstance = ConstantsType.BOOLEAN_PR_TYPE;
		} else if (type.equals(byte.class)) {
			typeInstance = ConstantsType.BYTE_PR_TYPE;
		} else if (type.equals(short.class)) {
			typeInstance = ConstantsType.SHORT_PR_TYPE;
		} else if (type.equals(char.class)) {
			typeInstance = ConstantsType.CHAR_PR_TYPE;
		} else if (type.equals(int.class)) {
			typeInstance = ConstantsType.INT_PR_TYPE;
		} else if (type.equals(long.class)) {
			typeInstance = ConstantsType.LONG_PR_TYPE;
		} else if (type.equals(float.class)) {
			typeInstance = ConstantsType.FLOAT_PR_TYPE;
		} else if (type.equals(double.class)) {
			typeInstance = ConstantsType.DOUBLE_PR_TYPE;
			// Objectes
		} else if (type.equals(Boolean.class)) {
			typeInstance = ConstantsType.BOOLEAN_TYPE;
		} else if (type.equals(Byte.class)) {
			typeInstance = ConstantsType.BYTE_TYPE;
		} else if (type.equals(Short.class)) {
			typeInstance = ConstantsType.SHORT_TYPE;
		} else if (type.equals(Character.class)) {
			typeInstance = ConstantsType.CHARACTER_TYPE;
		} else if (type.equals(Integer.class)) {
			typeInstance = ConstantsType.INTEGER_TYPE;
		} else if (type.equals(Long.class)) {
			typeInstance = ConstantsType.LONG_TYPE;
		} else if (type.equals(Float.class)) {
			typeInstance = ConstantsType.FLOAT_TYPE;
		} else if (type.equals(Double.class)) {
			typeInstance = ConstantsType.DOUBLE_TYPE;
			// Dates java.sql.Date
		} else if (type.equals(Date.class)) {
			typeInstance = ConstantsType.DATE_SQL_TYPE;
		} else if (type.equals(Time.class)) {
			typeInstance = ConstantsType.TIME_SQL_TYPE;
		} else if (type.equals(Timestamp.class)) {
			typeInstance = ConstantsType.TIMESTAMP_SQL_TYPE;
		}

		return typeInstance;
	}
}
