/**
 * 
 */
package edu.uoc.framework.process;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import edu.uoc.framework.DTO.DataConfig;
import edu.uoc.framework.exception.DataEmptyException;
import edu.uoc.framework.generator.dataconfig.DataConfigGenerator;
import edu.uoc.framework.generator.entity.DataEntityGenerator;

/**
 * @author JBuch
 *Classe que llegeix les entitys i crea per cada entity un objecte per a genera les dades.
 */
@Service
public class DataGeneratorProcess {

	
	private List<DataConfig> listDataConfig;
	private List<Object> listEntity;

	@Autowired
	DataConfigGenerator dataConfigGenerator;
	
	@Autowired
	DataEntityGenerator dataEntityGenerator;
	
	public DataGeneratorProcess() {
		this.listDataConfig = new ArrayList<>();
		this.listEntity = new ArrayList<>();
	}

	public List<Object> execute(List<Class<?>> listClass){
		
		createDataConfig(listClass);
		createListentity();
		
		return listEntity;
	}

	private void createListentity() {
		try{
			listEntity = dataEntityGenerator.getEntityList(listDataConfig);
		}catch(DataEmptyException e){
			e.printStackTrace();
			listDataConfig = new ArrayList<>();
		}
		
	}

	private void createDataConfig(List<Class<?>> listClass) {
		
		try{
			listDataConfig = dataConfigGenerator.getAllDataConfig(listClass);
		}catch(DataEmptyException e){
			e.printStackTrace();
			listDataConfig = new ArrayList<>();
		}
	}

	public List<DataConfig> getListDataConfig() {
		return listDataConfig;
	}

	public void setListDataConfig(List<DataConfig> listDataConfig) {
		this.listDataConfig = listDataConfig;
	}

	public List<Object> getListEntity() {
		return listEntity;
	}

	public void setListEntity(List<Object> listEntity) {
		this.listEntity = listEntity;
	}

}
