/**
 * 
 */
package edu.uoc.framework.process;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import edu.uoc.framework.exception.DataEmptyException;
import edu.uoc.framework.read.ReadPackageClass;

/**
 * @author JBuch
 *Classe que extreu les classes d'un paquet.
 */
@Service
public class ReadProcess {

	private List<Class<?>> listClass;
	
	@Autowired
	ReadPackageClass readPackageClass;
	
	public ReadProcess() {
		this.listClass = new ArrayList<>();
	}

	public List<Class<?>> execute(Package pkg){
		
		getClassList(pkg);
				
		return listClass;
	}

	private void getClassList(Package pkg) {
		try{
			listClass = readPackageClass.getClassesForPackage(pkg);
		}catch(DataEmptyException e){
			e.printStackTrace();
			listClass = new ArrayList<>();
		}
	}
	
	public List<Class<?>> getListClass() {
		return listClass;
	}
	
	public void setListClass(List<Class<?>> listClass) {
		this.listClass = listClass;
	}

}
